import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:ocg_user/src/bloc/user_block/event.dart';
import 'package:ocg_user/src/bloc/user_block/state.dart';
import 'package:ocg_user/src/repository/user.dart';

class UserBlockBloc extends Bloc<UserBlockEvent, UserBlockState> {
  final UserRepository userRepository;
  UserBlockBloc(this.userRepository) : super(UserBlockInitialState());

  @override
  Stream<UserBlockState> mapEventToState(UserBlockEvent event) async* {
    if (event is UserBlockStartEvent) {
      yield UserBlockLoadingState();
      var response =
          await userRepository.blockUser(event.userId, event.blocked);
      if (response.isSuccess) {
        yield UserBlockLoadedState(event.userId);
      } else {
        yield UserBlockErrorState(response.error);
      }
    }
  }
}
