import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:ocg_user/src/bloc/user_self/event.dart';
import 'package:ocg_user/src/bloc/user_self/state.dart';
import 'package:ocg_user/src/repository/user.dart';

class UserSelfBloc extends Bloc<UserSelfEvent, UserSelfState> {
  final UserRepository userRepository;
  UserSelfBloc(this.userRepository) : super(UserSelfIdleState());

  @override
  Stream<UserSelfState> mapEventToState(UserSelfEvent event) async* {
    if (event is UserSelfRefreshEvent) {
      yield UserSelfLoadingState();
      var response = await userRepository.getSelf();
      if (response.isSuccess) {
        yield UserSelfLoadedState(response.data);
      } else {
        yield UserSelfErrorState(response.error);
      }
    }
  }
}
