///
/// State
///

abstract class UserStatusState {
  final String userId;

  UserStatusState(this.userId);
}

class UserStatusInitialState extends UserStatusState {
  UserStatusInitialState() : super(null);
}

class UserStatusOnlineState extends UserStatusState {
  final DateTime lastSeen;

  UserStatusOnlineState(String userId, this.lastSeen) : super(userId);

  bool get isOnline =>
      DateTime.now().millisecondsSinceEpoch -
          (lastSeen ?? DateTime(1971)).millisecondsSinceEpoch <
      (25 * 1000);
}

class UserStatusLoadingState extends UserStatusState {
  UserStatusLoadingState(String userId) : super(userId);
}
